--message('Super annoying login message for Kicker to remind him that BeerCount is running! \n Type "/BeerCount Help" for the help menu.')

--BeerCountVars saves lifetime total and total for each individual drink
--BeerCountVars_SelectedDrink saves your selected drink between sessions

-------------------------------Locals Declared----------------------------------------------

currentBeerCount = 0

local phrases = {}
phrases[1] = "On "
phrases[2] = "On "
phrases[3] = "On "
phrases[4] = "On "
phrases[5] = "On "
phrases[6] = "On "

-------------------------------Local Saved Variables Declared---------------unused----------------

--local localBeerCountVars = {}
--local localBeerCountVars_SelectedDrink = ""

-------------------------------Buttons---------------------------------------------------------


local currentBeerButton = CreateFrame("Button", "BeerButton1", UIParent, 'UIPanelButtonTemplate')
      currentBeerButton:SetSize(200,20)
      currentBeerButton:SetPoint("CENTER",200,0)
      currentBeerButton:SetMovable(true)
      currentBeerButton:SetText('Add Drink')
      currentBeerButton:RegisterForClicks("LeftButtonUp")
      --currentBeerButton:SetScript("OnClick", function() func() end)
      currentBeerButton:SetAlpha(0.2)
      currentBeerButton:SetScript("OnEnter", function(self) self:SetAlpha(1) end)
      currentBeerButton:SetScript("OnLeave", function(self) self:SetAlpha(0.5) end)
      currentBeerButton:RegisterForDrag("LeftButton")
      currentBeerButton:SetScript("OnDragStart",currentBeerButton.StartMoving)
      currentBeerButton:SetScript("OnDragStop",function(self)
	 self:StopMovingOrSizing()
	-- settings.XPos = self:GetLeft()
	-- settings.YPos = self:GetBottom()
      end)

local lifetimeBeerButton = CreateFrame("Button", "BeerButton2", UIParent, 'UIPanelButtonTemplate')
      lifetimeBeerButton:SetSize(200,20)
      lifetimeBeerButton:SetPoint("CENTER",400,0)
      lifetimeBeerButton:SetMovable(true)
      lifetimeBeerButton:SetText('Display Lifetime Drink Count')
      lifetimeBeerButton:RegisterForClicks("LeftButtonUp")
      --lifetimeBeerButton:SetScript("OnClick", function() func2() end)
      lifetimeBeerButton:SetAlpha(0.2)
      lifetimeBeerButton:SetScript("OnEnter", function(self) self:SetAlpha(1) end)
      lifetimeBeerButton:SetScript("OnLeave", function(self) self:SetAlpha(0.5) end)
      lifetimeBeerButton:RegisterForDrag("LeftButton")
      lifetimeBeerButton:SetScript("OnDragStart",lifetimeBeerButton.StartMoving)
      lifetimeBeerButton:SetScript("OnDragStop",function(self)
	 self:StopMovingOrSizing()
	-- settings.XPos = self:GetLeft()
	-- settings.YPos = self:GetBottom()
      end)      

-------------------------------Login/Logout Event Frame and Setup Initial Saved Vars--------

local LoginoutFrame = CreateFrame("FRAME")
LoginoutFrame:RegisterEvent("ADDON_LOADED")
LoginoutFrame:RegisterEvent("PLAYER_LOGIN")
LoginoutFrame:RegisterEvent("PLAYER_LOGOUT")

function LoginoutFrame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "BeerCount" then
	
		--Decalre initial variables, addon variables are loaded at this point.
		-- localBeerCountVars = BeerCountVars
		-- localBeerCountVars_SelectedDrink = BeerCountVars_SelectedDrink
		if BeerCountVars == nil then
			BeerCountVars = {lifetimeBeerCount = 0}
		end
		
		if BeerCountVars["Beer"] == nil then
			BeerCountVars["Beer"] = 0
		end
		
		if BeerCountVars_SelectedDrink == nil then
			BeerCountVars_SelectedDrink = "Beer"
		end
		
		if BeerCountVars_Options == nil then
			BeerCountVars_Options = {showhide = "Show"}
		end
		
		if BeerCountVars_Options["channel"] == nil then
			BeerCountVars_Options["channel"] = "GUILD"
		end

		--setup button name based on last drink
		currentBeerButton:SetText('Add ' ..(BeerCountVars_SelectedDrink))
		
		currentLifetimeSelection = "lifetimeBeerCount"
				
	elseif event == "PLAYER_LOGIN" then
		print ('BeerCount: Your last drink choice was ' .. (BeerCountVars_SelectedDrink))
		print ('BeerCount: Your lifetime total is ' .. (BeerCountVars.lifetimeBeerCount))
	elseif event == "PLAYER_LOGOUT" then
		-- BeerCountVars = localBeerCountVars
		-- BeerCountVars_SelectedDrink = localBeerCountVars_SelectedDrink
	end
end

LoginoutFrame:SetScript("OnEvent", LoginoutFrame.OnEvent)

-------------------------------Functions---------------------------------------------------

--veryify number don't contain spaces, letters, or leading 0s.
function numberCheck(num)
	if tonumber(string.sub(num,1,1)) == 0 then --leading 0
		print("Please don't use leading 0's in your numbers.")
		return false
	elseif string.find(num," ") ~= nil then --space found
		print("Please don't use spaces in your numbers.")
		return false
	elseif tonumber(num) == nil then
		print("Please don't use letters in your numbers.") --letter found
		return false
	else
		return true
	end
end

--Order table data
function pairsByKeys (k, v)
	local a = {}
	for n in pairs(k) do table.insert(a, n) end
	table.sort(a, v)
	local i = 0      -- iterator variable
	local iter = function ()   -- iterator function
		i = i + 1
		if a[i] == nil then return nil
		else return a[i], k[a[i]]
		end
	end
	return iter
end

-- add all new drinks to the saved var to enable lifetime tracking
local function addDrinkToBeerCountVars(msg)
	if BeerCountVars[msg] == nil then
		BeerCountVars[msg] = 0
	end
end

--keeps track of what phrase to use
local function drinkingPhrases()
	if currentBeerCount == 5 then
		SendChatMessage(phrases[1] .. (BeerCountVars_SelectedDrink) .. " " .. (currentBeerCount), BeerCountVars_Options["channel"], nil)
	elseif currentBeerCount == 10 then
		SendChatMessage(phrases[2] .. (BeerCountVars_SelectedDrink) .. " " .. (currentBeerCount), BeerCountVars_Options["channel"], nil)
	elseif currentBeerCount == 15 then
		SendChatMessage(phrases[3] .. (BeerCountVars_SelectedDrink) .. " " .. (currentBeerCount), BeerCountVars_Options["channel"], nil)
	elseif currentBeerCount == 20 then
		SendChatMessage(phrases[4] .. (BeerCountVars_SelectedDrink) .. " " .. (currentBeerCount), BeerCountVars_Options["channel"], nil)
	elseif currentBeerCount == 25 then
		SendChatMessage(phrases[5] .. (BeerCountVars_SelectedDrink) .. " " .. (currentBeerCount), BeerCountVars_Options["channel"], nil)
	elseif currentBeerCount == 30 then
		SendChatMessage(phrases[6] .. (BeerCountVars_SelectedDrink) .. " " .. (currentBeerCount), BeerCountVars_Options["channel"], nil)
	else
		SendChatMessage("On " .. (BeerCountVars_SelectedDrink) .. " " .. (currentBeerCount), BeerCountVars_Options["channel"], nil)
	end
end

--adds a drink to current, drink lifetime, and total lifetime counters, perform the toast emote, call a phrase to be put into chat
local function addBeer()
	BeerCountVars.lifetimeBeerCount = BeerCountVars.lifetimeBeerCount + 1
	BeerCountVars[BeerCountVars_SelectedDrink] = BeerCountVars[BeerCountVars_SelectedDrink] +1
	currentBeerCount = currentBeerCount + 1
	drinkingPhrases()
	-- SendChatMessage("You raise a drink in the air before chugging it down.  Cheers!", "EMOTE")
	DoEmote("drink")
end

--display lifetime counter
local function displayLifetime()
	if currentLifetimeSelection == "lifetimeBeerCount" then
		SendChatMessage("Lifetime Drinks: " .. (BeerCountVars.lifetimeBeerCount), BeerCountVars_Options["channel"], nil)
	else
		SendChatMessage("Lifetime drinks of " ..(currentLifetimeSelection) ..": " .. (BeerCountVars[currentLifetimeSelection]), BeerCountVars_Options["channel"], nil)
	end
end

function channelSelect(channel)
	local upperChannel = string.upper(channel)
	if (upperChannel == "GUILD") or (upperChannel == "RAID") or (upperChannel == "SAY") or (upperChannel == "YELL") or (upperChannel == "PARTY") then
		BeerCountVars_Options["channel"] = upperChannel
		print('Channel is now: ' .. (upperChannel))
	else
		print('Invalid channel given: ' .. (upperChannel) ..  '. Use GUILD, RAID, SAY, YELL, or PARTY')
	end 
end

--hide buttons
function hideButtons()
	currentBeerButton:Hide()
	currentBeerButton:Disable()
	lifetimeBeerButton:Hide()
	lifetimeBeerButton:Disable()
	BeerCountVars_Options["showhide"] = "Hide"
end

--show buttons
function showButtons()
	currentBeerButton:Show()
	currentBeerButton:Enable()
	lifetimeBeerButton:Show()
	lifetimeBeerButton:Enable()
	BeerCountVars_Options["showhide"] = "Show"
end

--update drink
function changeDrink(drink)
	local charstart = string.sub(drink,1,1)
	local charend = string.sub(drink,-1,-1)
	if drink == "" then
		print ('You did not enter a drink.  Try again.')
	elseif charstart == " " then
		print ("Your drink, '" .. (drink) .. "', started with a space.  Try again.")
	elseif charend == " " then
		print ("Your drink, '" .. (drink) .. "', ended with a space.  Try again.")
	elseif drink == "lifetimeBeerCount" then
		print ("You can't select the total lifetime counter as a drink.")
	else
		BeerCountVars_SelectedDrink = drink
		print('Your selected drink is: ' .. (BeerCountVars_SelectedDrink))
		addDrinkToBeerCountVars(drink)
		currentBeerButton:SetText('Add ' ..(BeerCountVars_SelectedDrink))
	end
end

--update specific drink lifetime total
function lifetimeDrinkTotal(drink,value)
	local wasFound = false
	local numCheck = numberCheck(value)
	if numCheck == true then
		for k,v in pairs(BeerCountVars) do
			if k == drink then
				wasFound = true
			end
		end
		if wasFound == true then
			BeerCountVars[drink] = value
			print('Your lifetime total for ' .. (drink) .. ' has been set to: ' .. (BeerCountVars[drink]))
		else
			print((drink) .. ' was not found.  Select a drink you have used previously.')
		end
	end
end

--delete a drink from the lifetime list
function deleteDrink(drink)
	local deletedDrinkTable = {}
	local drinkFound = false
	if drink == "lifetimeBeerCount" then
		print("You can't delete the lifetime counter.")
	else
		for k,v in pairs(BeerCountVars) do
			if k == drink then
				drinkFound = true
			else	
				deletedDrinkTable[k] = v
			end
		end
		if drinkFound == true then
			BeerCountVars = deletedDrinkTable
			print ((drink) .. ' has been removed from your list.')
		else
			print ((drink) .. ' was not able to be removed.  It was not in your list of past drinks.')
		end
	end
end

--update lifetime counter
function updateLifetimeCounter(value)
	local numCheck = numberCheck(value)
	if numCheck == true then
		BeerCountVars.lifetimeBeerCount = value
		print('Your lifetime total has been set to: ' ..(BeerCountVars.lifetimeBeerCount))
	end
end

function updateCurrentSessionCounter(value)
	local numcheck = numberCheck(value)
	if numcheck == true then
		currentBeerCount = value
		print('Your current total has been set to: ' ..(value))
	end
end

function lifetimeSelect(drink)
	local wasfound = false
	for k,v in pairs(BeerCountVars) do
		if k == drink then
			wasfound = true
		end
	end
	if wasfound == true then
		if drink == "lifetimeBeerCount" then
			print('Default Lifetime Counter selected.')
			lifetimeBeerButton:SetText('Display Lifetime Drink Count')
		else
			print('Lifetime button will now display lifetime count of: ' ..(drink))
			lifetimeBeerButton:SetText('Display Lifetime ' .. (drink) .. ' Count')
		end
		currentLifetimeSelection = drink
	else
		print ('Please select a drink you have used before to set as your lifetime button.')
	end
end

currentBeerButton:SetScript("OnClick", function() addBeer() end)
lifetimeBeerButton:SetScript("OnClick", function() displayLifetime() end)






