local LoginoutOptionsFrame = CreateFrame("FRAME")
LoginoutOptionsFrame:RegisterEvent("ADDON_LOADED")

function LoginoutOptionsFrame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "BeerCount" then

		---------------------------------------------Init-----------------------------------------------------------------
		--setup previous show/hide option
		if BeerCountVars_Options["showhide"] == "Show" then
			showButtons()
		elseif BeerCountVars_Options["showhide"] == "Hide" then
			hideButtons()
		end
		
		--setup previous channel option
		channelSelect(BeerCountVars_Options["channel"])
		
		--setup inital lifetime button selection
		lifetimeSelect("lifetimeBeerCount")
		
		--init editbox var
		local editBoxDrink = ""
		---------------------------------------------End Init-----------------------------------------------------------------

		--Setup interface menu for addon.
		BeerCountOptions = {}
			BeerCountOptions.panel = CreateFrame( "Frame", "BeerCountPanel", UIParent )
			-- Register in the Interface Addon Options GUI
			-- Set the name for the Category for the Options Panel
			BeerCountOptions.panel.name = "BeerCount v" .. GetAddOnMetadata("BeerCount", "Version")
			-- Add the panel to the Interface Options
			InterfaceOptions_AddCategory(BeerCountOptions.panel)



		--------------------------------------------Create General Options Header-----------------------------------------------------------------
		local generalOptionsText=BeerCountOptions.panel:CreateFontString(nil,"OVERLAY","GameFontNormal")
		generalOptionsText:SetPoint("TOP",0,-20)
		generalOptionsText:SetText("General Options")

		local generalOptionsLine1 = BeerCountOptions.panel:CreateLine()
		generalOptionsLine1:SetColorTexture(1,0,0,1)
		generalOptionsLine1:SetStartPoint("TOPLEFT", 5,-25)
		generalOptionsLine1:SetEndPoint("TOP",-55,-25)

		local generalOptionsLine2 = BeerCountOptions.panel:CreateLine()
		generalOptionsLine2:SetColorTexture(1,0,0,1)
		generalOptionsLine2:SetStartPoint("TOP", 55, -25)
		generalOptionsLine2:SetEndPoint("TOPRIGHT", -5, -25)
		--------------------------------------------End General Options Header--------------------------------------------------------------------
		
		--------------------------------------------Create Show/Hide Label-----------------------------------------------------------------
		local showhideLabelText=BeerCountOptions.panel:CreateFontString(nil,"OVERLAY","GameFontNormal")
		showhideLabelText:SetPoint("TOPLEFT",15,-35)
		showhideLabelText:SetText("Show/Hide Buttons")
		--------------------------------------------End ShowHide Label--------------------------------------------------------------------
		--------------------------------------------Create Show/Hide List Drop Down-----------------------------------------------------------------
		local showhide_option = BeerCountVars_Options["showhide"]

		-- Create the dropdown, and configure its appearance
		local showhideDropDown = CreateFrame("FRAME", "showhideDropDown", BeerCountOptions.panel, "UIDropDownMenuTemplate")
			showhideDropDown:SetPoint("TOPLEFT", 0, -50)
			UIDropDownMenu_SetWidth(showhideDropDown, 60)
			UIDropDownMenu_SetText(showhideDropDown, showhide_option)


		-- Create and bind the initialization function to the dropdown menu
		UIDropDownMenu_Initialize(showhideDropDown, function(self, level, menuList)
			local showhideDropDowninfo = UIDropDownMenu_CreateInfo()
			showhideDropDowninfo.func = self.showhideDropDownFunction
			showhideDropDowninfo.text, showhideDropDowninfo.arg1, showhideDropDowninfo.checked = "Show", "Show", showhide_option == "Show" 
			UIDropDownMenu_AddButton(showhideDropDowninfo)
			showhideDropDowninfo.text, showhideDropDowninfo.arg1, showhideDropDowninfo.checked = "Hide", "Hide", showhide_option == "Hide"
			UIDropDownMenu_AddButton(showhideDropDowninfo)
		end)


		-- showhide dropdown function
		function showhideDropDown:showhideDropDownFunction(showhidearg)
			showhide_option = showhidearg
			-- Update showhide dropdown text
			UIDropDownMenu_SetText(showhideDropDown, showhide_option)
			if showhide_option == "Show" then
				showButtons()
			elseif showhide_option == "Hide" then
				hideButtons()
			else
				print ('showhide function error - how did we get here?')
			end
			CloseDropDownMenus()
		end
		--------------------------------------------End Show/Hide List Drop Down-----------------------------------------------------------------
		
		--------------------------------------------Create Channel Label-----------------------------------------------------------------
		local channelLabelText = BeerCountOptions.panel:CreateFontString(nil,"OVERLAY","GameFontNormal")
		channelLabelText:SetPoint("TOPLEFT",15,-100)
		channelLabelText:SetText("Channel Selection")
		--------------------------------------------End Channel Label--------------------------------------------------------------------
		--------------------------------------------Create Channel List Drop Down-----------------------------------------------------------------
		local channel_option = BeerCountVars_Options["channel"]

		-- Create the dropdown, and configure its appearance
		local channelDropDown = CreateFrame("FRAME", "channelDropDown", BeerCountOptions.panel, "UIDropDownMenuTemplate")
			channelDropDown:SetPoint("TOPLEFT", 0, -115)
			UIDropDownMenu_SetWidth(channelDropDown, 70)
			UIDropDownMenu_SetText(channelDropDown, channel_option)


		-- Create and bind the initialization function to the dropdown menu
		UIDropDownMenu_Initialize(channelDropDown, function(self, level, menuList)
			local channelDropDowninfo = UIDropDownMenu_CreateInfo()
			channelDropDowninfo.func = self.channelDropDownFunction
			channelDropDowninfo.text, channelDropDowninfo.arg1, channelDropDowninfo.checked  = "GUILD", "GUILD", channel_option == "GUILD"
			UIDropDownMenu_AddButton(channelDropDowninfo)
			channelDropDowninfo.text, channelDropDowninfo.arg1, channelDropDowninfo.checked = "RAID", "RAID", channel_option == "RAID"
			UIDropDownMenu_AddButton(channelDropDowninfo)
			channelDropDowninfo.text, channelDropDowninfo.arg1, channelDropDowninfo.checked = "SAY", "SAY", channel_option == "SAY"
			UIDropDownMenu_AddButton(channelDropDowninfo)
			channelDropDowninfo.text, channelDropDowninfo.arg1, channelDropDowninfo.checked = "YELL", "YELL", channel_option == "YELL"
			UIDropDownMenu_AddButton(channelDropDowninfo)
			channelDropDowninfo.text, channelDropDowninfo.arg1, channelDropDowninfo.checked = "PARTY", "PARTY", channel_option == "PARTY"
			UIDropDownMenu_AddButton(channelDropDowninfo)
		end)


		-- channel dropdown function
		function channelDropDown:channelDropDownFunction(channelarg)
			channel_option = channelarg
			-- Update showhide dropdown text
			UIDropDownMenu_SetText(channelDropDown, channel_option)
				channelSelect(channelarg)
			CloseDropDownMenus()
		end
		--------------------------------------------End Chanel List Drop Down-------------------------------------------------------------------
		
		--------------------------------------------Create Lifetime Selector Label-----------------------------------------------------------------
		local lifetimeSelectLabelText = BeerCountOptions.panel:CreateFontString(nil,"OVERLAY","GameFontNormal")
		lifetimeSelectLabelText:SetPoint("TOPLEFT",150,-100)
		lifetimeSelectLabelText:SetText("Lifetime Button Selection")
		--------------------------------------------End Lifetime Selector Label--------------------------------------------------------------------
		--------------------------------------------Create Lifetime Selector Drop Down-----------------------------------------------------------------
		local lifetimeSelected = currentLifetimeSelection

		-- Create the dropdown, and configure its appearance
		local lifetimeSelectDropDown = CreateFrame("FRAME", "lifetimeSelectDropDown", BeerCountOptions.panel, "UIDropDownMenuTemplate")
			lifetimeSelectDropDown:SetPoint("TOPLEFT", 135, -115)
			UIDropDownMenu_SetWidth(lifetimeSelectDropDown, 200)
			UIDropDownMenu_SetText(lifetimeSelectDropDown, "Default Lifetime Count")


		-- Create and bind the initialization function to the dropdown menu
		UIDropDownMenu_Initialize(lifetimeSelectDropDown, function(self, level, menuList)
			local lifetimeSelectDropDowninfo = UIDropDownMenu_CreateInfo()
			lifetimeSelectDropDowninfo.func = self.lifetimeSelectDropDownFunction
			lifetimeSelectDropDowninfo.text, lifetimeSelectDropDowninfo.arg1, lifetimeSelectDropDowninfo.checked  = "Default Lifetime Count", "lifetimeBeerCount", lifetimeSelected == "lifetimeBeerCount"
			UIDropDownMenu_AddButton(lifetimeSelectDropDowninfo)
			for k,v in pairsByKeys(BeerCountVars) do
				if k == "lifetimeBeerCount" then
					--handled above
				else
					lifetimeSelectDropDowninfo.text, lifetimeSelectDropDowninfo.arg1, lifetimeSelectDropDowninfo.checked = k, k, lifetimeSelected == k
					UIDropDownMenu_AddButton(lifetimeSelectDropDowninfo)
				end
			end
		end)


		-- lifetimeSelect dropdown function
		function lifetimeSelectDropDown:lifetimeSelectDropDownFunction(lifetimeSelectedarg)
		lifetimeSelected = lifetimeSelectedarg
		-- Update showhide dropdown text
		if lifetimeSelected == "lifetimeBeerCount" then
			UIDropDownMenu_SetText(lifetimeSelectDropDown, "Default Lifetime Count")
		else
			UIDropDownMenu_SetText(lifetimeSelectDropDown, lifetimeSelectedarg)
		end
		lifetimeSelect(lifetimeSelected)
		CloseDropDownMenus()
		end
		--------------------------------------------End Lifetime Selector Drop Down-------------------------------------------------------------------
	
		
		--------------------------------------------Start Lifetime Counters Delete Button---------------------------------------		
		
		local function drinkDeleteButton(drink, parent, func)
			local deleteButton = CreateFrame("Button", (drink) .. "Button", parent, 'UIPanelButtonTemplate')
			deleteButton:SetSize(25,20)
			deleteButton:SetPoint("RIGHT",25,0)
			deleteButton:SetText('X')
			deleteButton:RegisterForClicks("LeftButtonUp")
			deleteButton:SetScript("OnClick", function() func(drink) end)
			return deleteButton
		end
		--------------------------------------------End Lifetime Counters Delete Button---------------------------------------		
		
		
			
		--------------------------------------------Start Edit Box Code for Current Drink and Lifetime Counters---------------------------------------		

		--makes the text sbove the box
		function MakeText(parent, text, size)
		    local text_obj = parent:CreateFontString(nil, "ARTWORK")
		    text_obj:SetFont("Fonts/FRIZQT__.ttf", size)
		    text_obj:SetText(text)
		    text_obj:SetPoint("LEFT", 0, 0)
		    return text_obj
		end

		--makes the editbox
		function MakeEditBox(name, parent, title, boxWidth, boxHeight, enter_func, func_2)
			local edit_box_obj = CreateFrame("EditBox", name, parent)
			local previousText = edit_box_obj:GetText()
			edit_box_obj.title_text = MakeText(edit_box_obj, title, 12)
			edit_box_obj.title_text:SetPoint("TOP", 0, 12)
			edit_box_obj:SetBackdrop({
			bgFile = "Interface/Tooltips/UI-Tooltip-Background",
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
				tile = true,
				tileSize = 26,
				edgeSize = 16,
				insets = { left = 4, right = 4, top = 4, bottom = 4}
			})
			edit_box_obj:SetBackdropColor(0,0,0,1)
			edit_box_obj:SetSize(boxWidth, boxHeight)
			edit_box_obj:SetAutoFocus(false)
			edit_box_obj:SetMaxLetters(20)
			edit_box_obj:SetJustifyH("CENTER")
			edit_box_obj:SetFontObject(GameFontNormal)
			edit_box_obj:SetScript("OnEnterPressed", function(self)
				if self:GetText() ~= "" then
					enter_func(self)
					if func_2 ~= nil then
						func_2()
					end
					previousText = self:GetText()
				end
				self:ClearFocus()
			end)
			edit_box_obj:SetScript("OnEscapePressed", function(self)
				self:SetText(previousText)
				self:ClearFocus()
			end)
			edit_box_obj:SetScript("OnEditFocusLost", function(self)
				self:SetText(previousText)
			end)
			edit_box_obj:SetScript("OnMouseDown", function(self)
				if self:GetText() ~= "" then
					previousText = self:GetText()
					self:SetText("")
				end
				editBoxDrink = title
			end)
			return edit_box_obj
		end
		
		--makes the text sbove the box
		function MakeTextList(parent, text, size)
		    local text_obj = parent:CreateFontString(nil, "ARTWORK")
		    text_obj:SetFont("Fonts/FRIZQT__.ttf", size)
		    text_obj:SetText(text)
		    text_obj:SetPoint("LEFT", 0, 0)
		    return text_obj
		end
		
		--makes the editbox
		function MakeEditBoxList(name, parent, title, boxWidth, boxHeight, enter_func, func_2)
			local edit_box_obj = CreateFrame("EditBox", name, parent)
			local previousText = edit_box_obj:GetText()
			edit_box_obj.title_text = MakeTextList(edit_box_obj, title, 12)
			edit_box_obj.title_text:SetPoint("TOP", 0, 12)
			edit_box_obj:SetBackdrop({
			bgFile = "Interface/Tooltips/UI-Tooltip-Background",
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
				tile = true,
				tileSize = 26,
				edgeSize = 16,
				insets = { left = 4, right = 4, top = 4, bottom = 4}
			})
			edit_box_obj:SetBackdropColor(0,0,0,1)
			edit_box_obj:SetSize(boxWidth, boxHeight)
			edit_box_obj:SetAutoFocus(false)
			edit_box_obj:SetMaxLetters(20)
			edit_box_obj:SetJustifyH("CENTER")
			edit_box_obj:SetFontObject(GameFontNormal)
			edit_box_obj:SetScript("OnEnterPressed", function(self)
				if self:GetText() ~= "" then
					enter_func(self)
					if func_2 ~= nil then
						func_2()
					end
					previousText = self:GetText()
				end
				self:ClearFocus()
			end)
			edit_box_obj:SetScript("OnEscapePressed", function(self)
				self:SetText(previousText)
				self:ClearFocus()
			end)
			edit_box_obj:SetScript("OnEditFocusLost", function(self)
				self:SetText(previousText)
			end)
			edit_box_obj:SetScript("OnMouseDown", function(self)
				if self:GetText() ~= "" then
					previousText = self:GetText()
					self:SetText("")
				end
				editBoxDrink = title
			end)
			return edit_box_obj
		end
		

		--------------------------------------------End Edit Box Code for Current Drink and Lifetime Counters---------------------------------------

		--------------------------------------------Start Drinks List Edit Boxes----------------------------------------------------------------------
		
		drinkBoxes = {}
		local i = 0
		
		--function called when enter is pressed inside editbox
		local function drinksListFunc(drink)
			local drinkName = editBoxDrink
			local drinkValue = drink:GetText()
			local numcheck = numberCheck(drinkValue)
			--if (tonumber(drinkValue) ~= nil) and (tonumber(string.sub(drinkValue,1,1))) ~= 0 and (string.sub(drinkValue,-1,-1)) ~= " " then
			if numcheck == true then
				drink:SetText(drinkValue)
			else
				drink:SetText(BeerCountVars[drinkName])
			end
			lifetimeDrinkTotal(drinkName,drinkValue)
		end
		
		--Handles removing the editbox for deleted drinks
		function removeDeletedBox(drinkToRemove)
			deleteDrink(drinkToRemove)
			local boxes = {}
			local j = 0
			for k,v in pairsByKeys(drinkBoxes) do
			--for k,v in pairs(drinkBoxes) do
				if k == drinkToRemove then
					drinkBoxes[k]:Hide()
					drinkBoxes[k]:Disable()
					i = i - 25 -- account for removed editbox
				else
					if mod(j/25,4) == 0 then
						drinkBoxes[k]:SetPoint("TOPLEFT", 15, -175 - j)
					elseif mod(j/25,4) == 1 then
						drinkBoxes[k]:SetPoint("TOPLEFT", 165, -175 - (j - 25)) -- +25 for j offset due to being same var in all cases
					elseif mod(j/25,4) == 2 then
						drinkBoxes[k]:SetPoint("TOPLEFT", 315, -175 - (j - 50)) -- +50 for j offset due to being same var in all cases
					else
						drinkBoxes[k]:SetPoint("TOPLEFT", 465, -175 - (j - 75)) -- +75 for j offset due to being same var in all cases
					end
					j = j+25
					boxes[k] = v
				end
			end
			drinkBoxes = boxes
		end
		
		--creates all the edit boxes
		local function createDrinksBoxes()
		i = 0
			for k,v in pairsByKeys(BeerCountVars) do
			--for k,v in pairs(BeerCountVars) do
				if k == "lifetimeBeerCount" then
					--do nothing
				else	
					--Make Editboxs
					if drinkBoxes[k] == nil then
						local k_box = MakeEditBoxList((k) .. "EditBox", BeerCountOptions.panel, k, 50, 35, drinksListFunc)
						local k_button = drinkDeleteButton(k, k_box, removeDeletedBox)
						drinkBoxes[k] = k_box
					end
					if mod(i/25,4) == 0 then
						drinkBoxes[k]:SetPoint("TOPLEFT", 15, -175 - i)
					elseif mod(i/25,4) == 1 then
						drinkBoxes[k]:SetPoint("TOPLEFT", 165, -175 - (i - 25)) -- +25 for i offset due to being same var in all cases
					elseif mod(i/25,4) == 2 then
						drinkBoxes[k]:SetPoint("TOPLEFT", 315, -175 - (i - 50)) -- +50 for i offset due to being same var in all cases
					else
						drinkBoxes[k]:SetPoint("TOPLEFT", 465, -175 - (i - 75)) -- +75 for i offset due to being same var in all cases
					end
					drinkBoxes[k]:SetText(BeerCountVars[k])
					drinkBoxes[k]:SetCursorPosition(0)
					i = i+25
				end
			end
		end
		
		createDrinksBoxes()

		--------------------------------------------End Drinks List Edit Boxes----------------------------------------------------------------------

		--------------------------------------------Create Current Drink Label-----------------------------------------------------------------
		local currentDrinkLabelText=BeerCountOptions.panel:CreateFontString(nil,"OVERLAY","GameFontNormal")
		currentDrinkLabelText:SetPoint("TOPLEFT", 280, -35)
		currentDrinkLabelText:SetText('Current Drink: ' .. (BeerCountVars_SelectedDrink))
		--------------------------------------------End Current Drink Label--------------------------------------------------------------------
		
		--------------------------------------------Start Current Drink Edit Box----------------------------------------------------------------------
		
		--function called when enter is pressed inside editbox
		local function updateDrink(drink)
			local newDrink = drink:GetText()
			changeDrink(newDrink)
			drink:SetText("")
			currentDrinkLabelText:SetText('Current Drink: ' .. (BeerCountVars_SelectedDrink))
		end

		--calls/creates editbox
		local currentDrinkEditBox = MakeEditBox(currentDrinkEditBox, BeerCountOptions.panel, "Enter Drink", 150, 30, updateDrink, createDrinksBoxes)
		currentDrinkEditBox:SetPoint("TOPLEFT", 280, -65)
		--------------------------------------------End Current Drink Edit Box----------------------------------------------------------------------

		--------------------------------------------Create Lifetime Total Label-----------------------------------------------------------------
		lifetimeTotalLabelText=BeerCountOptions.panel:CreateFontString(nil,"OVERLAY","GameFontNormal")
		lifetimeTotalLabelText:SetPoint("TOPLEFT", 450, -35)
		lifetimeTotalLabelText:SetText('Lifetime Total: ' .. (BeerCountVars.lifetimeBeerCount))
		--------------------------------------------End Lifetime Total Label--------------------------------------------------------------------
		
		--------------------------------------------Start Lifetime Total Edit Box----------------------------------------------------------------------
		
		--function called when enter is pressed inside editbox
		local function updateLifetime(drink)
			local value = drink:GetText()
			local numCheck = numberCheck(value)
			if numCheck == true then
				updateLifetimeCounter(value)
				lifetimeTotalLabelText:SetText('Lifetime Total: ' .. (BeerCountVars.lifetimeBeerCount))
			else
				drink:SetText(BeerCountVars.lifetimeBeerCount)
			end
		end

		--calls/creates editbox
		lifetimeTotalEditBox = MakeEditBox(lifetimeTotalEditBox, BeerCountOptions.panel, "Lifetime Total", 50, 30, updateLifetime)
		lifetimeTotalEditBox:SetPoint("TOPLEFT", 450, -65)
		lifetimeTotalEditBox:SetText(BeerCountVars.lifetimeBeerCount)
		lifetimeTotalEditBox:SetCursorPosition(0)
		--------------------------------------------End Lifetime Total Edit Box----------------------------------------------------------------------
	
		--------------------------------------------Create Current Drink Total Label-----------------------------------------------------------------
		currentDrinkTotalLabelText = BeerCountOptions.panel:CreateFontString(nil,"OVERLAY","GameFontNormal")
		currentDrinkTotalLabelText:SetPoint("TOPLEFT", 150, -35)
		currentDrinkTotalLabelText:SetText('Current Number: ' .. (currentBeerCount))
		--------------------------------------------End Current Drink Total Label--------------------------------------------------------------------

		--------------------------------------------Start Current Drink Total Edit Box----------------------------------------------------------------------

		--function called when enter is pressed inside editbox
		local function updateSessionCounter(drink)
			local value = drink:GetText()
			local numCheck = numberCheck(value)
			if numCheck == true then
				updateCurrentSessionCounter(value)
				currentDrinkTotalLabelText:SetText('Current Number: ' .. (currentBeerCount))
			else
				drink:SetText(currentBeerCount)
			end
		end

		--calls/creates editbox
		currentDrinkTotalEditBox = MakeEditBox(currentDrinkTotalEditBox, BeerCountOptions.panel, "Current Number", 50, 30, updateSessionCounter)
		currentDrinkTotalEditBox:SetPoint("TOPLEFT", 150, -65)
		currentDrinkTotalEditBox:SetText(currentBeerCount)
		currentDrinkTotalEditBox:SetCursorPosition(0)
		--------------------------------------------End Current Drink Total Edit Box----------------------------------------------------------------------
	
		
		
		--------------------------------------------Create Drinks List Header--------------------------------------------------------------------
		local drinksListText=BeerCountOptions.panel:CreateFontString(nil,"OVERLAY","GameFontNormal");
		drinksListText:SetPoint("TOP",0,-145);
		drinksListText:SetText("Drinks List"); 

		local drinksListLine1 = BeerCountOptions.panel:CreateLine()
		drinksListLine1:SetColorTexture(1,0,0,1)
		drinksListLine1:SetStartPoint("TOPLEFT", 5,-150)
		drinksListLine1:SetEndPoint("TOP",-35,-150)

		local drinksListLine2 = BeerCountOptions.panel:CreateLine()
		drinksListLine2:SetColorTexture(1,0,0,1)
		drinksListLine2:SetStartPoint("TOP", 35, -150)
		drinksListLine2:SetEndPoint("TOPRIGHT", -5, -150)
		--------------------------------------------End Drinks List Header----------------------------------------------------------------------
		







      
	end -- ends if event == "ADDON_LOADED" and arg1 == "BeerCount" then   
end -- ends function LoginoutOptionsFrame:OnEvent(event, arg1)

LoginoutOptionsFrame:SetScript("OnEvent", LoginoutOptionsFrame.OnEvent)