-------------------------------Slash Command---------------------------------------------------------  

local function BeerCountSlashCommand(msg, editbox)
	local lowercasecommand = string.lower(msg)
	local command, arg1, arg2 = strsplit(" ",msg)
	if command == "help" then
		print ('Type /BeerCount <drink> to change your drink for the evening.')
		print ('Type /BeerCount Lifetime to display all of your lifetime totals.')
		print ('Type /BeerCount Lifetime <#> to modify your lifetime total.')
		print ('Type /BeerCount Current <#> to modify your current session total.')
		print ('Type /BeerCount Lifetime <drink> <#> to modify a specific drink lifetime total.')
		print ('Type /BeerCount Hide to hide and disable the buttons.')
		print ('Type /BeerCount Show to show and enable the buttons.')
		print ('Type /BeerCount Channel <Channel to type to> Use one of the following: GUILD, RAID, SAY, YELL, or PARTY')
		print ('Type /BeerCount Delete <Drink> to remove the selected drink from your lifetime list.')
		print ('Type /BeerCount lifetimeButton <Drink> to change which drink the lifetime button displays.')
	elseif command == "lifetime" and arg1 and arg2 then
		lifetimeDrinkTotal(arg1,arg2)
		local numcheck = numberCheck(arg2)
		local wasfound = false
		for k,v in pairs(BeerCountVars) do
			if k == arg1 then
				wasfound = true
			end
		end
		if wasfound == true then
			if numcheck == true then
				drinkBoxes[arg1]:SetText(arg2)
			end
		end
	elseif command == "lifetime" and arg1 then
		updateLifetimeCounter(arg1)
		local numcheck = numberCheck(arg1)
		if numcheck == true then
			lifetimeTotalEditBox:SetText(arg1)
			lifetimeTotalLabelText:SetText('Lifetime Total: ' .. (arg1))
		end
	elseif command == "current" and arg1 then
		updateCurrentSessionCounter(arg1)
		local numcheck = numberCheck(arg1)
		if numcheck == true then
			currentDrinkTotalEditBox:SetText(arg1)
			currentDrinkTotalLabelText:SetText('Current Number: ' .. (arg1))
		end
	elseif command == "lifetime" then
		for k,v in pairsByKeys(BeerCountVars) do
			if k == "lifetimeBeerCount" then
				-- do nothing
			else	
				print(k, ': ', v)
			end
		end
		print('Lifetime Counter is at: ' ..(BeerCountVars.lifetimeBeerCount))
	elseif command == "hide" then
		hideButtons()
		UIDropDownMenu_SetText(showhideDropDown, "Hide")
	elseif command == "show" then
		showButtons()
		UIDropDownMenu_SetText(showhideDropDown, "Show")
	elseif command == "channel" and arg1 then
		channelSelect(arg1)
		local upperChannel = string.upper(arg1)
		if (upperChannel == "GUILD") or (upperChannel == "RAID") or (upperChannel == "SAY") or (upperChannel == "YELL") or (upperChannel == "PARTY") then
			UIDropDownMenu_SetText(channelDropDown, upperChannel)
		end
	elseif command == "delete" and arg1 then
		deleteDrink(arg1)
	elseif command == "lifetimeButton" and arg1 then
		lifetimeSelect(arg1)
		local wasfound = false
		for k,v in pairs(BeerCountVars) do
			if k == arg1 then
				wasfound = true
			end
		end
		if wasfound == true then
			UIDropDownMenu_SetText(lifetimeSelectDropDown, arg1)
		end
	else
		changeDrink(msg)
	end
end

SLASH_BeerCount1 = '/BeerCount'
SlashCmdList["BeerCount"] = BeerCountSlashCommand
